import _extends from "@babel/runtime/helpers/esm/extends";
import { generate } from '@ant-design/colors';
import { defaultPresetColors } from '../seed';
import genColorMapToken from '../shared/genColorMapToken';
import genCommonMapToken from '../shared/genCommonMapToken';
import { generateBgPalettes, generateColorPalettes, generateTextAlphaPalettes } from './palettes';
export default function derivative(token) {
  var colorPalettes = Object.keys(defaultPresetColors).map(function (colorKey) {
    var colors = generate(token[colorKey], {
      theme: 'dark'
    });
    return new Array(10).fill(1).reduce(function (prev, _, i) {
      prev["".concat(colorKey, "-").concat(i + 1)] = colors[i];
      return prev;
    }, {});
  }).reduce(function (prev, cur) {
    prev = _extends(_extends({}, prev), cur);
    return prev;
  }, {});
  var colorBgBase = token.colorBgBase || '#000';
  var colorTextBase = token.colorTextBase || '#fff';
  return _extends(_extends(_extends(_extends(_extends({}, token), colorPalettes), {
    colorBgBase: colorBgBase,
    colorTextBase: colorTextBase
  }), genColorMapToken(_extends(_extends({}, token), {
    colorBgBase: colorBgBase,
    colorTextBase: colorTextBase
  }), {
    generateColorPalettes: generateColorPalettes,
    generateBgPalettes: generateBgPalettes,
    generateTextAlphaPalettes: generateTextAlphaPalettes
  })), genCommonMapToken(token));
}